package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.UserGroupDetailMapper;
import com.sa.ibiz.demo.demo.domain.UserGroupDetail;
import com.sa.ibiz.demo.demo.service.UserGroupDetailService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.UserGroupDetailSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.UserGroupService;
import com.sa.ibiz.demo.demo.service.UserObjectService;

/**
 * 实体[UserGroupDetail] 服务对象接口实现
 */
@Service
public class UserGroupDetailServiceImpl extends ServiceImplBase<UserGroupDetailMapper, UserGroupDetail> implements UserGroupDetailService{

    @Autowired
    private UserGroupService usergroupService;
    @Autowired
    private UserObjectService userobjectService;

    @Resource
    private UserGroupDetailMapper usergroupdetailMapper;


    @Override
    public boolean create(UserGroupDetail et) {
        this.beforeCreate(et);
        String primaryKey=et.getUsergroupdetailid();
        if(StringUtils.isEmpty(primaryKey))
        {
            primaryKey=(String)et.getDefaultPrimaryKey();
            et.setUsergroupdetailid(primaryKey);
         }
         return super.create(et);
    }
    @Override
	public UserGroupDetail get(UserGroupDetail et) {
        String primaryKey=et.getUsergroupdetailid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setUsergroupdetailid(primaryKey);
          }
		      return super.get(et);
	}

    @Override
   	public boolean remove(UserGroupDetail et) {
        String primaryKey=et.getUsergroupdetailid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setUsergroupdetailid(primaryKey);
          }
   		     return super.remove(et);
   	}

    @Override
    public boolean update(UserGroupDetail et){
        String primaryKey=et.getUsergroupdetailid();
         if(StringUtils.isEmpty(primaryKey))
         {
             primaryKey=(String)et.getDefaultPrimaryKey();
             et.setUsergroupdetailid(primaryKey);
          }
		     this.usergroupdetailMapper.updateOne(et);
		     this.get(et);
             return true;
    }


    public Object getEntityKey(UserGroupDetail et){
		return et.getUsergroupdetailid();  
    }

    @Override
    public boolean getDraft(UserGroupDetail et)  {
    if((!StringUtils.isEmpty(et.getUsergroupid())) && et.getUsergroup() == null){
            try {
                et.setUsergroup(usergroupService.getById(et.getUsergroupid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getUserobjectid())) && et.getUserobject() == null){
            try {
                et.setUserobject(userobjectService.getById(et.getUserobjectid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<UserGroupDetail> listDefault(UserGroupDetailSearchFilter filter) {
		return usergroupdetailMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<UserGroupDetail> searchDefault(UserGroupDetailSearchFilter filter) {
		return usergroupdetailMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return usergroupdetailMapper.selectRow(sql);
    }

 }